include head.h
# numlam is the number of the lambda points
# each lambda has NPH/2+1 k's. k is stored in kk, and corresponding seminorm
# of |x|, and |wx-y| in y-axis and x-axis.
program plot
integer numlam
parameter (numlam=NUMLAM)
real lambda(numlam,NPH/2+1), xx(numlam,NPH/2+1), yy(numlam,NPH/2+1)
integer kk,i
character*20 tx,ty,title

open (1, file='lcurves')
do i=1,numlam{
    do k=1,NPH/2+1{
	read(1,*) lambda(i,k), kk, xx(i,k), yy(i,k)
    }
}
close (1)

open (2, file='klcurves')
do k=1, NPH/2+1{
    do i=1, numlam{
	write(2,*) k, lambda(i,k), xx(i,k), yy(i,k)
    }
}
close(2)

open (3, file='indexlam')
do i=1, numlam {
    write (3,*) i, lambda(i,1)
}
close(3)	

tx='residue: |wx-y|'
ty='|x|'
title='L-Curve'

do k=1,NPH/2+1 {
    call plot3(yy(1,k),xx(1,k),lambda(1,k),numlam,tx,ty,title)	
}
end


subroutine plot3(x,y,z,n,tx, ty, titl)
# x,y,z are 1D array with n elements
# tx, ty, title are the titl for x-axis, y-axis and the whole graphic
# x, y, z are all >0
integer n
real x(n), y(n), z(n)
character*20 tx, ty, titl
real xmin, xmax, ymin, ymax, zmin, zmax

xmin=1.
xmax=0.
ymin=1.
ymax=0.
zmin=1.
zmax=0.

do i=1, n {
	if ( xmin > x(i) ) { xmin=x(i) }
	if ( xmax < x(i) ) { xmax=x(i) }
}

do i=1, n {
	if ( ymin > y(i) ) { ymin=y(i) }
	if ( ymax < y(i) ) { ymax=y(i) }
}

do i=1, n {
	if ( zmin > z(i) ) { zmin=z(i) }
	if ( zmax < z(i) ) { zmax=z(i) }
}

print *, 'xmin  ', xmin, '  xmax  ', xmax
print *, 'ymin  ', ymin, '  ymax  ', ymax
print *, 'zmin  ', zmin, '  zmax  ', zmax

# change mins and maxes to log
xmin=aint(log10(xmin))-1
xmax=aint(log10(xmax))+1
ymin=aint(log10(ymin))-1
ymax=aint(log10(ymax))+1
zmin=aint(log10(zmin))-1
zmax=aint(log10(zmax))+1


call METAFL ('xwin')  
#call clrmod('full')
call DISINI
#call NEWPAG
call COMPLX 
call PAGERA  
call axspos(450, 1800)
call ax3len(2000,1400,1400)
call name (tx, 'x')  
call name (ty, 'y')    
call SCALE('LOG', 'xyz') 
call labels('log','xyz')
call graf3(xmin,xmax,xmin,1.,ymin,ymax,ymin,1.,zmin,zmax,zmin,1.) 
call titlin(titl, 1)
call title
call setres(5,5)
call curve3(x,y,z,n)
call DISFIN 

return
end
